from m5.params import *
from m5.proxy import *
from PhysicalMemory import *

class DrSim(PhysicalMemory):
    type = 'DrSim'

    drsim_config = Param.String('', 'DrSim config string')
    stat_print_period = Param.Tick(0, 'DrSim periodic stat printout interval')
    output_file = Param.String('drsim-output.txt', 'Stat output file name')
    use_ingress_q = Param.Bool(True, 'Use ingress queue of the DrSim')
    response_delay = Param.Tick(0, 'Return response delay in ticks')
    cpu_priority_mod = Param.Int(0, 'Cpu priority modifier')
    et_enabled = Param.Bool(False, 'Enable event tracing')
    et_start = Param.Tick(0, 'Enable event tracing')
    et_end = Param.Tick(1000000000, 'Enable event tracing')
