use Text::ParseWords;

sub extract
{
	my $infile = shift @_;
	my $element = shift @_;
	my $loc = shift @_;
	my $cnt = shift @_;
  my $vert_offset = shift @_;

	my $rval = "NOT_FOUND";
	
	open INFILE, "<", $infile or die $!;
	while( <INFILE> ) {
		if( m/^$element/ ) {
      for (my $i = 0; $i < $vert_offset; $i++) {
        $_ = <INFILE>;
      }
      $_ =~ tr/':'/' '/;
      my @words = &quotewords('\s+', 0, $_);
      if( $cnt == 0 ) { 
        if( $loc eq "last" ) { 
#print $words[$#words-1] . "\t" ;;
					$rval = $words[$#words-1];
        } else {
#print $words[$loc] . "\t" ;;
					$rval = $words[$loc];
        }   
        last;
      } else { 
        $cnt--;
      }   
		}
	}
	close( INFILE );
#	if( $rval == -1 ) { die("can't find $element in $infile"); }

	return $rval;
}

for ($i = 0; $i <= 2; $i++) { 
  $mcas="--multi_cas $i";
  system("../dsim --subrank_width 1 $mcas $dsimdbg ./one.trace > $i.out");
  $ph_cw_avg = extract("$i.out", "ch0.mc_dist_time_to_PH_cw.sample_average", "last", 0, 0);
  $ph_cw_cnt = extract("$i.out", "ch0.mc_dist_time_to_PH_cw.total", "last", 0, 0);
  $ph_noncw_avg = extract("$i.out", "ch0.mc_dist_time_to_PH_noncw.sample_average", "last", 0, 0);
  $ph_noncw_cnt = extract("$i.out", "ch0.mc_dist_time_to_PH_noncw.total", "last", 0, 0);

  $rd_cw_avg = extract("$i.out", "ch0.mc_dist_time_to_RD_cw.sample_average", "last", 0, 0);
  $rd_cw_cnt = extract("$i.out", "ch0.mc_dist_time_to_RD_cw.total", "last", 0, 0);
  $rd_noncw_avg = extract("$i.out", "ch0.mc_dist_time_to_RD_noncw.sample_average", "last", 0, 0);
  $rd_noncw_cnt = extract("$i.out", "ch0.mc_dist_time_to_RD_noncw.total", "last", 0, 0);

  if ($ph_cw_avg == 11 and $ph_cw_cnt == 1 and $ph_noncw_avg == 11 and $ph_noncw_cnt == 7 and
      $rd_cw_avg ==  0 and $rd_cw_cnt == 1 and $rd_noncw_avg == 16 and $rd_noncw_cnt == 7) {
      print "pass\n";
  } else {
    print "$ph_cw_avg, $ph_cw_cnt, $ph_noncw_avg, $ph_noncw_cnt, $rd_cw_avg, $rd_cw_cnt, $rd_noncw_avg, $rd_noncw_cnt\n";
  }
}

system("rm 0.out 1.out 2.out");
